const Cc = Components.classes;
const Ci = Components.interfaces;
const Cu = Components.utils;

Cu.import ('resource://shrunked/shrunked.jsm');

var images = window.arguments [0]; // [{ url }, ... ]
var returnValues = window.arguments [1];
var maxWidth = returnValues.maxWidth;
var maxHeight = returnValues.maxHeight;
var quality = Shrunked.prefs.getIntPref ('default.quality');

var i = 0;
var iCount = images.length;

var progress = document.getElementById ('progress');
progress.max = iCount;
var progressText = document.getElementById ('progressText');
progressText.value = '0/' + iCount;

window.onload = function () {
	try {
		var j = 0;
		var interval = setInterval (function () {
			if (j == iCount) {
				clearInterval (interval);
			} else {
				doResize (images [j++]);
			}
		}, 150);
	} catch (e) {
		Components.utils.reportError (e);
	}
}

function doResize (image) {
	Shrunked.enqueue (document, image.url, maxWidth, maxHeight, quality, function (destFile) {
		progress.setAttribute ('value', ++i);
		progressText.setAttribute ('value', i + '/' + iCount);
		image.destFile = destFile;

		if (i == iCount) {
			returnValues.cancelDialog = false;
			setTimeout (function () {
				window.close ();
			}, 150);
		}
	});
}
